Index: libabac/abac_pl_gen.c
===================================================================
--- libabac/abac_pl_gen.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_pl_gen.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -16,10 +16,9 @@
 // index to generate C1,C2..
 static int cred_count=0;
-extern char* abac_yyfptr;
+extern char* abac_yyfptr_encoded;
 extern int abac_cnt_yy_id_certs();
 extern void abac_free_yy_id_certs();
 extern char *abac_string_yy_id_certs();
-char *abac_role_principal_cn(abac_role_t *role);
-char *abac_type_clauses=NULL;
+char *abac_addon_clauses=NULL;
 
 /***********************************************************************/
@@ -33,5 +32,5 @@
 static char *_compose_cred_list()
 {
-    int i=cred_count;;
+    int i=cred_count;
     if(cred_count==0) return "";
 
@@ -47,5 +46,4 @@
     return clist;
 }
-
 
 /* generate role(p_name, r_name, param..) */
@@ -161,54 +159,182 @@
 
 
-static char *generate_pl_rule_clause(char *head_role_string, abac_role_t *tail_role)
+/* generate oset(p_name, r_name, param..) */
+static char* generate_pl_head_oset_string(abac_oset_t *oset)
+{
+     char *tmp=NULL;
+     char *principalname=abac_oset_principal_cn(oset);
+     char *osetname=abac_oset_oset_name(oset);
+     char *param_string=NULL;
+     int cnt=0;
+
+     /* can not be a linked role */
+     abac_param_list_t *oset_params=abac_oset_oset_params(oset);
+     if(oset_params) {
+        param_string=abac_param_list_string(oset_params);
+     }
+
+     if (param_string != NULL) {
+         cnt=asprintf(&tmp,"oset(%s,%s,%s)", principalname, osetname, param_string);
+         free(param_string);
+         } else {
+             cnt=asprintf(&tmp,"oset(%s,%s)", principalname, osetname);
+     }
+     if(cnt>0)
+        return tmp;
+        else
+           return NULL;
+}
+
+/* generate oset(p_name, r_name, param..) with isMember call ?? */
+static char* generate_pl_tail_oset_string(abac_oset_t *oset)
+{
+     char *tmp;
+/*
+   A.oset <- B
+   A.oset <- Obj
+   A.oset <- B.oset
+   A.oset <- B.role.oset
+*/
+     /* o */
+     if(abac_oset_is_object(oset)) {
+         char *objectname=abac_oset_object_cn(oset);
+         tmp=abac_xstrdup(objectname);
+         return tmp;
+     } else {
+         char *principalname=abac_oset_principal_cn(oset);
+         char *osetname=abac_oset_oset_name(oset);
+         char *linkedname=abac_oset_linked_role(oset);
+
+         char *param_string=NULL;
+         char *linked_param_string=NULL;
+         int cnt=0;
+
+         abac_param_list_t *oset_params=abac_oset_oset_params(oset);
+         if(oset_params) {
+             param_string=abac_param_list_string(oset_params);
+         }
+
+         abac_param_list_t *linked_role_params=abac_oset_linked_role_params(oset);
+         if(linked_role_params) {
+             linked_param_string=abac_param_list_string(linked_role_params);
+         }
+
+         /* b.r.r */
+         if(linkedname!=NULL && osetname!=NULL && principalname!=NULL ) {
+             int fst=_get_next_cred_idx();
+             int snd=_get_next_cred_idx();
+             if(linked_param_string !=NULL) {
+                 if (param_string != NULL) {
+                     cnt=asprintf(&tmp,"isMember(Y,role(%s,%s,%s),C%d),isMember(X,oset(Y,%s,%s),C%d)",
+                                principalname,
+                                linkedname,linked_param_string,fst,
+                                osetname,param_string,snd);
+                     free(param_string);
+                     } else {
+                         cnt=asprintf(&tmp,"isMember(Y,role(%s,%s,%s),C%d),isMember(X,oset(Y,%s),C%d)",
+                                principalname,
+                                linkedname,linked_param_string,fst,
+                                osetname,snd);
+                 }
+                 free(linked_param_string);
+                 } else {
+                     if (oset_params != NULL) {
+                         cnt=asprintf(&tmp,"isMember(Y,role(%s,%s),C%d),isMember(X,oset(Y,%s,%s),C%d)",
+                                principalname,
+                                linkedname,fst,
+                                osetname,param_string,snd);
+                         free(param_string);
+                         } else {
+                             cnt=asprintf(&tmp,"isMember(Y,role(%s,%s),C%d),isMember(X,oset(Y,%s),C%d)",
+                                principalname,
+                                linkedname,fst,
+                                osetname,snd);
+                   }
+             }
+             if(cnt>0)
+                 return tmp;
+                 else
+                     return NULL;
+         } 
+         /* b.r */
+         if(linkedname==NULL && osetname!=NULL && principalname!=NULL ) {
+             int fst=_get_next_cred_idx();
+             if(param_string != NULL) {
+                 cnt=asprintf(&tmp,"isMember(X,oset(%s,%s,%s),C%d)",
+                              principalname, osetname, param_string, fst);
+                 free(param_string);
+                 } else {
+                     cnt=asprintf(&tmp,"isMember(X,oset(%s,%s),C%d)",
+                              principalname, osetname, fst);
+             }
+             if(cnt>0)
+                 return tmp;
+                 else
+                     return NULL;
+         } 
+         /* b */
+         if(linkedname==NULL && osetname==NULL && principalname!=NULL ) {
+             tmp=abac_xstrdup(principalname);
+             return tmp;
+         } 
+
+    }
+    return tmp;
+}
+
+
+/********************************************************************************/
+
+static char *_build_constraint_rule_clause(char *head_string, char *tail_string)
+{
+    /*only,  A.R <- B */
+    char *tmp;
+    int idx=_get_next_cred_idx();
+    asprintf(&tmp, "isMember(%s,%s,C%d)", tail_string,head_string,idx);
+    return tmp;
+}
+
+static char *_build_rule_clause(char *rolename, char *head_string, char *tail_string)
 {
     char *tmp=NULL;
-    char* tail_role_string=NULL;
-    char* rolename=abac_role_role_name(tail_role);
 
     if(rolename == NULL) {
         /* A.R <- B */
-        tail_role_string=generate_pl_tail_role_string(tail_role);
-        if(tail_role_string != NULL) {
-            if(abac_type_clauses==NULL) {
-                asprintf(&tmp, "isMember(%s,%s,['%s'])",
-                         tail_role_string,head_role_string,abac_yyfptr);
-                } else {
-                    asprintf(&tmp, "isMember(%s,%s,['%s']) :- %s",
-                         tail_role_string,head_role_string,abac_yyfptr,
-                         abac_type_clauses);
-                    free(abac_type_clauses);
-                    abac_type_clauses=NULL;
-            }
-            } else { 
-                goto error;
+        if(abac_addon_clauses==NULL) {
+            asprintf(&tmp, "isMember(%s,%s,['%s'])",
+                     tail_string,head_string,abac_yyfptr_encoded);
+            } else {
+                asprintf(&tmp, "isMember(%s,%s,['%s']) :- %s",
+                     tail_string,head_string,abac_yyfptr_encoded,
+                     abac_addon_clauses);
+                free(abac_addon_clauses);
+                abac_addon_clauses=NULL;
         }
         } else {
              /* A.R <- B.R */
              /* A.R <- B.R.R */
-             tail_role_string=generate_pl_tail_role_string(tail_role);
              if (cred_count==0) {
-                 if(abac_type_clauses==NULL) { 
+                 if(abac_addon_clauses==NULL) {
                      asprintf(&tmp,"isMember(X,%s,['%s']):-%s",
-                           head_role_string, abac_yyfptr, tail_role_string);
+                           head_string, abac_yyfptr_encoded, tail_string);
                      } else {
                          asprintf(&tmp,"isMember(X,%s,['%s']):-%s, %s",
-                                 head_role_string, abac_yyfptr,
-                                 tail_role_string, abac_type_clauses);
-                         free(abac_type_clauses);
-                         abac_type_clauses=NULL;
+                                 head_string, abac_yyfptr_encoded,
+                                 tail_string,abac_addon_clauses);
+                         free(abac_addon_clauses);
+                         abac_addon_clauses=NULL;
                  }
                  } else {
                      char *tmp_cred_list=_compose_cred_list();
-                     if(abac_type_clauses == NULL) {
-                         asprintf(&tmp,"isMember(X,%s,L):-%s, appendL([['%s'],%s],L)", 
-                                  head_role_string, tail_role_string,
-                                  abac_yyfptr, tmp_cred_list);
+                     if(abac_addon_clauses == NULL) {
+                         asprintf(&tmp,"isMember(X,%s,L):-%s, appendL([['%s'],%s],L)",
+                                  head_string, tail_string,
+                                  abac_yyfptr_encoded, tmp_cred_list);
                          } else {
-                             asprintf(&tmp,"isMember(X,%s,L):-%s, appendL([['%s'],%s],L), %s", 
-                                  head_role_string, tail_role_string,
-                                  abac_yyfptr, tmp_cred_list, abac_type_clauses);
-                             free(abac_type_clauses);
-                             abac_type_clauses=NULL;
+                             asprintf(&tmp,"isMember(X,%s,L):-%s, %s, appendL([['%s'],%s],L)",
+                                  head_string, tail_string, abac_addon_clauses,
+                                  abac_yyfptr_encoded, tmp_cred_list);
+                             free(abac_addon_clauses);
+                             abac_addon_clauses=NULL;
                      }
                      free(tmp_cred_list);
@@ -216,4 +342,15 @@
              }
     }
+    return tmp;
+}
+
+
+static char *generate_pl_rule_role_clause(char *head_role_string, abac_role_t *tail_role)
+{
+    char *rolename=abac_role_role_name(tail_role);
+    char *tail_role_string=generate_pl_tail_role_string(tail_role);
+    if(rolename == NULL && tail_role_string == NULL) 
+        goto error;
+    char *tmp=_build_rule_clause(rolename,head_role_string, tail_role_string);
     if(tail_role_string) free(tail_role_string);
     return tmp;
@@ -223,4 +360,20 @@
     return NULL;
 }
+
+static char *generate_pl_rule_oset_clause(char *head_oset_string, abac_oset_t *tail_oset)
+{
+    char *osetname=abac_oset_oset_name(tail_oset);
+    char *tail_oset_string=generate_pl_tail_oset_string(tail_oset);
+    if(osetname == NULL && tail_oset_string == NULL) 
+        goto error;
+    char *tmp=_build_rule_clause(osetname,head_oset_string, tail_oset_string);
+    if(tail_oset_string) free(tail_oset_string);
+    return tmp;
+
+error:
+    if(tail_oset_string) free(tail_oset_string);
+    return NULL;
+}
+
 
 static char *_add_string(char *dstr, char *nstr)
@@ -239,6 +392,39 @@
 }
 
-static char *generate_pl_intersecting_clause(char *head_role_string,
-                                                     abac_role_t *tail_role)
+static char *_build_intersecting_clause(char *head_role_string, char *tail_role_string)
+{
+    char *tmp;
+
+    if (cred_count==0) {
+        if(abac_addon_clauses ==NULL) {
+            asprintf(&tmp,"isMember(X,%s,['%s']):-%s",
+                   head_role_string, abac_yyfptr_encoded, tail_role_string);
+            } else {
+                asprintf(&tmp,"isMember(X,%s,['%s']):-%s, %s",
+                       head_role_string, abac_yyfptr_encoded, tail_role_string,
+                       abac_addon_clauses);
+                free(abac_addon_clauses);
+                abac_addon_clauses=NULL;
+        }
+        } else {
+            char *tmp_cred_list=_compose_cred_list();
+            if(abac_addon_clauses ==NULL) {
+                asprintf(&tmp,"isMember(X,%s,L):-%s, appendL([['%s'],%s],L)",
+                                head_role_string, tail_role_string,
+                                abac_yyfptr_encoded, tmp_cred_list);
+                } else {
+                    asprintf(&tmp,"isMember(X,%s,L):-%s, appendL([['%s'],%s],L), %s",
+                                head_role_string, tail_role_string,
+                                abac_yyfptr_encoded, tmp_cred_list,abac_addon_clauses);
+                    free(abac_addon_clauses);
+                    abac_addon_clauses=NULL;
+            }
+            free(tmp_cred_list);
+            cred_count=0;
+    }
+    return tmp;
+}
+
+static char *generate_pl_intersecting_role_clause(char *head_role_string, abac_role_t *tail_role)
 {
     char *tmp=NULL;
@@ -259,46 +445,55 @@
     }
 
-    if (cred_count==0) {
-        if(abac_type_clauses ==NULL) {
-            asprintf(&tmp,"isMember(X,%s,['%s']):-%s",
-                   head_role_string, abac_yyfptr, tail_role_string);
-            } else {
-                asprintf(&tmp,"isMember(X,%s,['%s']):-%s, %s",
-                       head_role_string, abac_yyfptr, tail_role_string,
-                       abac_type_clauses);
-                free(abac_type_clauses);
-                abac_type_clauses=NULL;
-        }
-        } else {
-            char *tmp_cred_list=_compose_cred_list();
-            if(abac_type_clauses ==NULL) {
-                asprintf(&tmp,"isMember(X,%s,L):-%s, appendL([['%s'],%s],L)", 
-                                head_role_string, tail_role_string,
-                                abac_yyfptr, tmp_cred_list);
-                } else {
-                    asprintf(&tmp,"isMember(X,%s,L):-%s, appendL([['%s'],%s],L), %s", 
-                                head_role_string, tail_role_string,
-                                abac_yyfptr, tmp_cred_list,abac_type_clauses);
-                    free(abac_type_clauses);
-                    abac_type_clauses=NULL;
-            }
-            free(tmp_cred_list);
-            cred_count=0;
-    }
+    tmp=_build_intersecting_clause(head_role_string, tail_role_string);
     if(tail_role_string) free(tail_role_string);
     return tmp;
 }
 
+static char *generate_pl_intersecting_oset_clause(char *head_oset_string, abac_oset_t *tail_oset)
+{
+    char *tmp=NULL;
+    char* tail_oset_string=NULL;
+    abac_list_t *list=abac_oset_prereqs(tail_oset);
+    /* A.O <- B.O & C.R.O */
+
+    if (list != NULL) {
+        abac_oset_t *cur;
+        abac_list_foreach(list, cur,
+            char *ntmp=generate_pl_tail_oset_string(cur);
+            if(tail_oset_string==NULL)
+                 asprintf(&tail_oset_string,"%s",ntmp);
+                 else
+                    asprintf(&tail_oset_string,"%s, %s",tail_oset_string,ntmp);
+            free(ntmp);
+        );
+    }
+
+    tmp=_build_intersecting_clause(head_oset_string, tail_oset_string);
+    if(tail_oset_string) free(tail_oset_string);
+    return tmp;
+}
+
 /* generate the yap isMember rule clause for the credential stmt */
-abac_list_t *generate_pl_clauses(abac_role_t *head_role, abac_role_t *tail_role)
+abac_list_t *generate_pl_role_clauses(abac_role_t *head_role, abac_role_t *tail_role)
 {
    char *tmp=NULL;
    abac_list_t *clauses=abac_list_new();
-
+  
    int cnt=abac_cnt_yy_id_certs();
    if(cnt > 0) { /* string it up */
-       abac_type_clauses=abac_string_yy_id_certs();
+       //abac_addon_clauses=abac_string_yy_id_certs();
+       tmp=abac_string_yy_id_certs();
        abac_free_yy_id_certs();
    }
+
+   cnt=abac_cnt_yy_constraints();
+   if(cnt > 0) {
+      char *ntmp=abac_string_yy_constraints();
+      abac_free_yy_constraints();
+      if(tmp)
+          asprintf(&tmp,"%s,%s",tmp,ntmp);
+          else tmp=ntmp;
+   }
+   abac_addon_clauses=tmp; 
 
 /* generate head's role string */
@@ -309,10 +504,11 @@
 /* tail side */
     if(abac_role_is_intersection(tail_role)) {
-       tmp=generate_pl_intersecting_clause(head_role_string, tail_role);
+       tmp=generate_pl_intersecting_role_clause(head_role_string, tail_role);
        } else {
-           tmp=generate_pl_rule_clause(head_role_string, tail_role);
+           tmp=generate_pl_rule_role_clause(head_role_string, tail_role);
     }
     if(tmp==NULL)
         goto error;
+ 
     abac_list_add(clauses,tmp);
     return clauses;
@@ -322,4 +518,98 @@
     return clauses;
 }
+
+abac_list_t *generate_pl_oset_clauses(abac_oset_t *head_oset, abac_oset_t *tail_oset)
+{
+   char *tmp=NULL;
+   abac_list_t *clauses=abac_list_new();
+
+   int cnt=abac_cnt_yy_id_certs();
+   if(cnt > 0) { /* string it up */
+       tmp=abac_string_yy_id_certs();
+       abac_free_yy_id_certs();
+   }
+
+   cnt=abac_cnt_yy_constraints();
+   if(cnt > 0) {
+      char *ntmp=abac_string_yy_constraints();
+      abac_free_yy_constraints();
+      if(tmp)
+          asprintf(&tmp,"%s,%s",tmp,ntmp);
+          else tmp=ntmp;
+   }
+   abac_addon_clauses=tmp; 
+
+/* generate head's oset string */
+    char *head_oset_string=generate_pl_head_oset_string(head_oset);
+    if(head_oset_string == NULL)
+        goto error;
+    
+/* tail side */
+    if(abac_oset_is_intersection(tail_oset)) {
+       tmp=generate_pl_intersecting_oset_clause(head_oset_string, tail_oset);
+       } else {
+           tmp=generate_pl_rule_oset_clause(head_oset_string, tail_oset);
+    }
+    if(tmp==NULL)
+        goto error;
+
+    abac_list_add(clauses,tmp);
+    return clauses;
+
+error:
+    if(head_oset_string) free(head_oset_string);
+    return clauses;
+}
+
+/* should be just 1 */
+char *generate_pl_role_constraint_clause(abac_role_t *head_role, char *tail_string)
+{
+/* generate head's role string */
+    char *head_role_string=generate_pl_head_role_string(head_role);
+    if(head_role_string == NULL)
+        goto error;
+
+/* tail side */
+    char *tmp=_build_constraint_rule_clause(head_role_string, tail_string);
+    if(tmp==NULL)
+        goto error;
+
+    return tmp;
+
+error:
+    if(head_role_string) free(head_role_string);
+    return NULL;
+}
+
+
+
+/* so far, for integer type only */
+char *generate_pl_range_constraint_clause(char *typestr,char *var,char *val,char *op)
+{
+   char *tmp=NULL;
+   asprintf(&tmp,"%s(%s)%s%s",typestr,var,op,val);
+   return tmp;
+}
+
+/* should just be 1 clause */
+char *generate_pl_oset_constraint_clause(abac_oset_t *head_oset,
+char *tail_string)
+{
+/* generate head's oset string */
+    char *head_oset_string=generate_pl_head_oset_string(head_oset);
+    if(head_oset_string == NULL)
+        goto error;
+
+/* tail side */
+    char *tmp=_build_constraint_rule_clause(head_oset_string, tail_string);
+    if(tmp==NULL)
+        goto error;
+
+    return tmp;
+error:
+    if(head_oset_string) free(head_oset_string);
+    return NULL;
+}
+
 
 /* generate the yap isType rule clause for the type,
Index: libabac/abac_pl_yap.c
===================================================================
--- libabac/abac_pl_yap.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_pl_yap.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -21,8 +21,11 @@
 
 extern char *abac_cn_with_role(abac_role_t *);
-extern abac_list_t *abac_credential_clauses(abac_credential_t *cred);
+extern char *abac_cn_with_oset(abac_oset_t *);
+extern abac_list_t *abac_credential_clauses(abac_credential_t *);
+extern char *abac_id_clause(abac_id_cert_t *);
+
 static int debug=0;
 
-// pl
+// pl -- place holder for now 
 struct _abac_pl_t {
     FILE *fptr;
@@ -56,5 +59,5 @@
 {
     char lstr[]="listing";
-    YAP_Term *eterm;
+    YAP_Term *eterm; /* error term */
 
     printf("\n\n========= yap db (%s)\n",msg);
@@ -164,5 +167,5 @@
 }
 
-/* cases,
+/* cases, 
      ['str']
      ['str1','str2']
@@ -197,5 +200,5 @@
              free(string); 
              if(cred) {
-                 abac_stack_push(credentials, cred);
+                 abac_stack_unique_push(credentials, cred);
                  cnt++;
                  } else {
@@ -211,5 +214,5 @@
                  free(string);
                  if(cred) {
-                     abac_stack_push(credentials, cred);
+                     abac_stack_unique_push(credentials, cred);
                      cnt++;
                      } else {
@@ -224,54 +227,166 @@
 }
 
-/* 2 types 
-      acme.buys_rocket <- coyote (coyote=prin, acme.buys_rocket=role)
-      acme.buys_rocket <- acme.preferred_customer  -- NOT DONE YET */
-static abac_stack_t *_query(abac_pl_t *pl, abac_role_t* role, abac_role_t* role_prin )
+
+static abac_stack_t *_make_yap_query(char *cn_prin, char *cn_rule, char* estring)
 {
     YAP_Term *eterm;
     YAP_Term arg[3];
-    char tmp[2000];
+    char tmp[5000];
     abac_stack_t *cred_list = abac_stack_new();
 
-    if(debug)
-        _show_yap_db("DEBUG:calling within _query");
-
-    char *cn_prin=abac_cn_with_role(role_prin);
-    char *cn_role=abac_cn_with_role(role);
-
-    if(abac_role_role_name(role_prin)!=NULL) {
-        printf("fail, a.r <- b.r query is not implemented yet !!!\n");
-        YAP_Exit(1);
-    }
-
-    if (cn_prin == NULL || cn_role == NULL) {
-        printf("fail, query's call got bad roles.. \n");
-        YAP_Exit(1);
-    }
-    sprintf(tmp,"role(%s,%s)", cn_role, abac_role_role_name(role));
+    if(debug) printf(" the role part(%s)\n", estring);
     arg[0]=YAP_MkAtomTerm(YAP_LookupAtom(cn_prin));
-    arg[1]=YAP_ReadBuffer(tmp,eterm);
+    if(debug) printf(" the principal part(%s)\n", cn_prin);
+    arg[1]=YAP_ReadBuffer(estring,eterm);
     arg[2]=YAP_MkVarTerm();
     YAP_Atom f = YAP_LookupAtom("isMember");
     YAP_Functor func = YAP_MkFunctor(f, 3);
     YAP_Term goal=YAP_MkApplTerm(func, 3, arg);
+
     int rc =YAP_RunGoal( goal );
     if (rc) {
-        printf("success, query call ok.. \n");
-        YAP_WriteBuffer(arg[2], tmp, 2000,YAP_WRITE_HANDLE_VARS);
-        /* printf("    answer : %s(%d)\n", tmp, strlen(tmp)); */
+        printf("YAP query succeed\n");
+        YAP_WriteBuffer(arg[2], tmp, 5000,YAP_WRITE_HANDLE_VARS);
+        if(debug) printf("    query answer : %s\n", tmp);
+        /* this is returned as ['string1','string2'] */
+        _credentials_from_string(cred_list,tmp); 
+/**** XXX somehow this got stuck in yap ???
+        while (YAP_RestartGoal()) {
+            if(debug) printf("another success\n");
+            YAP_WriteBuffer(arg[2], tmp, 5000,YAP_WRITE_HANDLE_VARS);
+            if(debug) printf("    query answer : %s\n", tmp); 
+            _credentials_from_string(cred_list,tmp); 
+        }
+***/
+    } else {
+        printf("YAP query failed\n");
+        /* YAP_Exit(1); */
+    }
+    return cred_list;
+}
+
+/* 2 types 
+      acme.buys_rocket <- coyote (coyote=prin, acme.buys_rocket=role)
+        ==> isMember(coyote,role(acme,buys_rocket), L)
+
+      acme.buys_rocket <- acme.preferred_customer  -- NOT DONE YET */
+static abac_stack_t *_query_with_role(abac_pl_t *pl, abac_role_t* role, abac_role_t* role_prin)
+{
+    char tmp[5000];
+    abac_stack_t *ret=NULL;
+
+    if(1)
+        _show_yap_db("DEBUG:calling within _query_with_role");
+
+    char *cn_prin=abac_cn_with_role(role_prin);
+    char *cn_role=abac_cn_with_role(role);
+
+    if(abac_role_role_name(role_prin)!=NULL) {
+        printf("fail, a.r <- b.r query is not implemented yet !!!\n");
+        YAP_Exit(1);
+    }
+
+    if (cn_prin == NULL || cn_role == NULL) {
+        printf("fail, query's call got bad roles.. \n");
+        YAP_Exit(1);
+    }
+
+    if(debug) printf("printing up the yap query ..\n");
+    char *pstring=abac_role_role_param_string(role);
+    if(pstring) {
+        sprintf(tmp,"role(%s,%s,%s)", cn_role, abac_role_role_name(role),pstring);
+        free(pstring);
+        } else {
+            sprintf(tmp,"role(%s,%s)", cn_role, abac_role_role_name(role));
+    }
+    ret=_make_yap_query(cn_prin,cn_role,tmp);
+    return ret;
+}
+
+static abac_stack_t *_query_with_oset(abac_pl_t *pl, abac_oset_t* oset, abac_oset_t* oset_obj)
+{
+    char tmp[5000];
+    abac_stack_t *ret=NULL;
+
+    if(debug)
+        _show_yap_db("DEBUG:calling within _query_with_oset");
+
+    char *cn_oset=abac_cn_with_oset(oset);
+    /* could be obj or principal */
+    char *cn_prin=NULL;
+    if(abac_oset_is_object(oset_obj)) {
+        cn_prin=abac_oset_object_cn(oset_obj);
+        } else {
+            cn_prin=abac_oset_principal_cn(oset_obj);
+    }
+
+    if(abac_oset_oset_name(oset_obj)!=NULL) {
+        printf("fail, a.o <- b.o query is not implemented yet !!!\n");
+        YAP_Exit(1);
+    }
+
+    if (cn_prin == NULL || cn_oset == NULL) {
+        printf("fail, query's call got bad oset.. \n");
+        YAP_Exit(1);
+    }
+
+    if(debug) printf("printing up the yap query ..\n");
+    char *pstring=abac_oset_oset_param_string(oset);
+    if(pstring) {
+        sprintf(tmp,"oset(%s,%s,%s)", cn_oset, abac_oset_oset_name(oset),pstring);
+        free(pstring);
+        } else {
+            sprintf(tmp,"oset(%s,%s)", cn_oset, abac_oset_oset_name(oset));
+    }
+
+    ret=_make_yap_query(cn_prin,cn_oset,tmp);
+    return ret;
+}
+
+static abac_stack_t *_dump(abac_pl_t *pl)
+{
+    YAP_Term *eterm;
+    YAP_Term arg[3];
+    char tmp[5000];
+    abac_stack_t *cred_list = abac_stack_new();
+
+    if(debug)
+        _show_yap_db("DEBUG:calling within _dump");
+
+    arg[0]=YAP_MkVarTerm();
+    arg[1]=YAP_MkVarTerm();
+    arg[2]=YAP_MkVarTerm();
+    YAP_Atom f = YAP_LookupAtom("isMember");
+    YAP_Functor func = YAP_MkFunctor(f, 3);
+    YAP_Term goal=YAP_MkApplTerm(func, 3, arg);
+
+    int rc =YAP_RunGoal( goal );
+    if (rc) {
+        printf("YAP dump succeed\n");
+        YAP_WriteBuffer(arg[2], tmp, 5000,YAP_WRITE_HANDLE_VARS);
+        if(debug) printf("    dump answer : %s\n", tmp);
         /* this is returned as ['string1','string2'] */
         _credentials_from_string(cred_list,tmp); 
         while (YAP_RestartGoal()) {
-            printf("another success\n");
-            YAP_WriteBuffer(arg[2], tmp, 2000,YAP_WRITE_HANDLE_VARS);
-            /* printf("    answer : %s\n", tmp); */
+            if(debug) printf("another dump success\n");
+            YAP_WriteBuffer(arg[2], tmp, 5000,YAP_WRITE_HANDLE_VARS);
+            if(debug) printf("    dump restart answer : %s\n", tmp);
             _credentials_from_string(cred_list,tmp); 
         }
     } else {
-        printf("fail, query's call is bad.. \n");
-        YAP_Exit(1);
+        printf("YAP _dump query failed\n");
+        /* YAP_Exit(1); */
     }
     return cred_list;
+}
+
+/**
+ * Get all the credentials (attribute/issuer cert pairs) from prolog
+ * (which returns in string form)
+ */
+abac_stack_t *abac_pl_credentials(abac_pl_t *pl)
+{
+    abac_stack_t *ret=_dump(pl);
+    return ret;
 }
 
@@ -280,29 +395,36 @@
 --role acme.preferred_customer --principal coyote
 --role acme.prefer_customer.buy_rockets --principlal coyote
+--oset acme.rockets -- object mrx-21 
+--oset acme.villans -- principal coyote
  */
-abac_stack_t *abac_pl_query(abac_pl_t *pl, char *role_name, char *principal)
-{
-    abac_role_t *role = abac_role_from_string(role_name);
-    abac_role_t *prin_role = abac_role_from_string(principal);
+abac_stack_t *abac_pl_query(abac_pl_t *pl, char *roleoset, char *prinobj)
+{
     abac_stack_t *ret=NULL;
-
-    // give up on bogus roles
-    if (role == NULL || prin_role == NULL) {
+    int len=strlen(roleoset)+strlen(prinobj)+5;
+    char* attr_string=(char *) abac_xmalloc(sizeof(char)*len);
+    sprintf(attr_string,"%s<-%s", roleoset, prinobj);
+
+    if(debug)
+        printf("abac_pl_query, query string is (%s)\n",attr_string);
+
+    /* call into yacc parser */
+    abac_reset_yyfptr(attr_string);
+    abac_yyinit();
+    int rc=yyparse();
+    if (rc) {
+        free(attr_string);
         return NULL;
     }
 
-    ret=_query(pl,role,prin_role);
-
+    if(abac_get_yap_is_oset()) {
+        abac_oset_t *head_oset = abac_get_yap_head_oset();
+        abac_oset_t *tail_oset = abac_get_yap_tail_oset();
+        ret=_query_with_oset(pl,head_oset,tail_oset);
+        } else {
+            abac_role_t *head_role = abac_get_yap_head_role();
+            abac_role_t *tail_role = abac_get_yap_tail_role();
+            ret=_query_with_role(pl,head_role,tail_role);
+    }
     return ret;
-}
-
-/**
- * Get all the credentials (attribute/issuer cert pairs) from prolog
- * (which returns in string form)
- */
-abac_stack_t *abac_pl_credentials(abac_pl_t *pl) {
-    abac_stack_t *credentials = abac_stack_new();
-    /* fix up a stream to stream the credentials from prolog engine */
-    return credentials;
 }
 
